//
//  LIVDocument.m
//  Large Image Viewer
//
//  Created by Tom Bernard on 10/11/06.
//  Copyright Bersearch Information Services 2006 . All rights reserved.
//

#import "LIVDocument.h"
#import "LIVOpenGLView.h"

@implementation LIVDocument


/*
+ (NSSet *)typesToOpen
{
	return [NSSet setWithObjects:@"TIFF", @"tiff", @"TIF", @"tif", @"GIF", @"gif", @"JPEG", @"jpeg", @"JPG", @"jpg", @"png", nil];
}
 */

/*
 + (NSArray *)readableTypes
{
	return [NSArray arrayWithObjects:@"TIFF", @"tiff", @"TIF", @"tif", @"GIF", @"gif", @"JPEG", @"jpeg", @"JPG", @"jpg", @"png", nil];
}
*/


- (id)init
{
    self = [super init];
    if (self) {
    
        // Add your subclass-specific initialization here.
        // If an error occurs here, send a [self release] message and return nil.
    
    }
    return self;
}


- (NSString *)windowNibName
{
    // Override returning the nib file name of the document
    // If you need to use a subclass of NSWindowController or if your document supports multiple NSWindowControllers, you should remove this method and override -makeWindowControllers instead.
    return @"LIVDocument";
}

- (void)windowControllerDidLoadNib:(NSWindowController *) aController
{
    [super windowControllerDidLoadNib:aController];
    // Add any code here that needs to be executed once the windowController has loaded the document's window.
	
	// NSRect windowFrameForImageRep = [self windowFrameForImageRep];
	
	// BOOL loadSuceeded = [livOpenGLView loadTilesFromImageRep:imageRep];
}

- (NSData *)dataRepresentationOfType:(NSString *)aType
{
    // Insert code here to write your document from the given data.  You can also choose to override -fileWrapperRepresentationOfType: or -writeToFile:ofType: instead.
    
    // For applications targeted for Tiger or later systems, you should use the new Tiger API -dataOfType:error:.  In this case you can also choose to override -writeToURL:ofType:error:, -fileWrapperOfType:error:, or -writeToURL:ofType:forSaveOperation:originalContentsURL:error: instead.

    return nil;
}


/*
 depracated
 
- (BOOL)loadDataRepresentation:(NSData *)data ofType:(NSString *)aType
{
    // Insert code here to read your document from the given data.  You can also choose to override -loadFileWrapperRepresentation:ofType: or -readFromFile:ofType: instead.
    // For applications targeted for Tiger or later systems, you should use the new Tiger API readFromData:ofType:error:.  In this case you can also choose to override -readFromURL:ofType:error: or -readFromFileWrapper:ofType:error: instead.
	
	imageRep = [[NSBitmapImageRep imageRepWithData:data] retain];
	
    return YES;
}
 */


- (BOOL)readFromData:(NSData *)data ofType:(NSString *)typeName error:(NSError **)outError
{
	// imageRep = [[NSBitmapImageRep imageRepWithData:data] retain];
	[self setImageRep:[NSBitmapImageRep imageRepWithData:data]];
	// currentEvent = [NSApp currentEvent];
	
    return YES;
}

/*
 */
 - (NSSize)windowWillResize:(NSWindow *)sender toSize:(NSSize)proposedFrameSize
{
	NSSize adjustedSize;
	
	// get deltas between window frame and content view frame
	NSRect windowFrame = [sender frame];
	NSRect windowContentViewFrame = [[sender contentView] frame];
	float deltaWidth = windowFrame.size.width - windowContentViewFrame.size.width;
	float deltaHeight = windowFrame.size.height - windowContentViewFrame.size.height;
	
	// calulate proposed content view size
	float proposedContentWidth = proposedFrameSize.width - deltaWidth;
	float proposedContentHeight = proposedFrameSize.height - deltaHeight;
	
	// get image aspect ratio
	LIVOpenGLView *livView = (LIVOpenGLView *)[[[sender contentView] subviews] objectAtIndex:0];
	float imageAspectRatio = [livView imageAspectRatio];
	
	// calculate new size
	if (imageAspectRatio > 1.0)
	{
		adjustedSize.width = proposedContentHeight / imageAspectRatio;
		adjustedSize.height = proposedContentHeight;
	}
	else
	{
		adjustedSize.width = proposedContentWidth;
		adjustedSize.height = proposedContentWidth * imageAspectRatio;
	}
	adjustedSize.width += deltaWidth;
	adjustedSize.height += deltaHeight;
	
	return adjustedSize;
}


 - (NSRect)windowWillUseStandardFrame:(NSWindow *)sender defaultFrame:(NSRect)defaultFrame
{
	NSRect _defaultFrame = defaultFrame;
	float windowDeltaWidth, windowDeltaHeight;
	NSRect windowFrame, contentViewFrame, desiredContentRect;
	
	windowFrame = [sender frame];
	contentViewFrame = [[sender contentView] frame];
	windowDeltaWidth = windowFrame.size.width - contentViewFrame.size.width;
	windowDeltaHeight = windowFrame.size.height - contentViewFrame.size.height;
	
	LIVOpenGLView *livView = (LIVOpenGLView *)[[[sender contentView] subviews] objectAtIndex:0];
	float imageAspectRatio = [livView imageAspectRatio];
	NSRect visibleFrame = [[NSScreen mainScreen] visibleFrame];
	float var = visibleFrame.size.height / visibleFrame.size.width;
	
	if (var > imageAspectRatio)
	{
		desiredContentRect = NSMakeRect(0.0, 0.0, defaultFrame.size.width - windowDeltaWidth, 0.0);
		desiredContentRect.size.height = desiredContentRect.size.width * imageAspectRatio;
	}
	else 
	{
		desiredContentRect = NSMakeRect(0.0, 0.0, 0.0, defaultFrame.size.height - windowDeltaHeight);
		desiredContentRect.size.width = desiredContentRect.size.height / imageAspectRatio;
	}
	
	_defaultFrame = [sender frameRectForContentRect:desiredContentRect];
	return _defaultFrame;
}


- (NSBitmapImageRep *)imageRep
{
	return imageRep;
}


- (void)setImageRep:(NSBitmapImageRep *)_rep
{
	[_rep retain];
	[imageRep release];
	imageRep = _rep;
}



@end
