//
//  Tile.h
//  Large Image Viewer
//
//  Created by Tom Bernard on 10/19/06.
//  Copyright 2006 Bersearch Information Services. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import <OpenGL/gl.h>
#import <OpenGL/glext.h>


@interface Tile : NSObject 
{
	GLuint tileTexture, tileTexelWidth, tileTexelHeight, tileRow, tileColumn;
	unsigned int bitsPerSample;
	NSString *colorspaceName;
	GLdouble x1, y1, x2, y2, x3, y3, x4, y4;
	GLdouble s1, t1, s2, t2, s3, t3, s4, t4;
	BOOL tileNeedsFlip, imageHasAlpha;
}
// + (unsigned char *)allocateTextureBitmapDataRows:(int)tpRows colums:(int)tpColumns samplesPerPixel:(int)spp bitsPerSample:(int)bps;

- (id)initWithTexelWidth:(GLuint)_width 
			 texelHeight:(GLuint)_height 
					 row:(GLuint)_row
				  column:(GLuint)_column
		   tileNeedsFlip:(BOOL)_needsFlip
		   colorspaeName:(NSString *)_colorspaceName
		   imageHasAlpha:(BOOL)_imageHasAlpha
		   bitsPerSample:(unsigned int)_bitsPerSample
				  pixels:(const GLvoid *)_pixels;

- (void)setVerticeX1:(GLdouble)_x1
				  y1:(GLdouble)_y1
				  x2:(GLdouble)_x2
				  y2:(GLdouble)_y2
				  x3:(GLdouble)_x3
				  y3:(GLdouble)_y3
				  x4:(GLdouble)_x4
				  y4:(GLdouble)_y4;

- (void)getVerticeX1:(GLdouble *)_x1
				  y1:(GLdouble *)_y1
				  x2:(GLdouble *)_x2
				  y2:(GLdouble *)_y2
				  x3:(GLdouble *)_x3
				  y3:(GLdouble *)_y3
				  x4:(GLdouble *)_x4
				  y4:(GLdouble *)_y4;

- (GLdouble)x1;
- (GLdouble)y1;

- (GLdouble)x2;
- (GLdouble)y2;

- (GLdouble)x3;
- (GLdouble)y3;

- (GLdouble)x4;
- (GLdouble)y4;

- (void)setTextureCoordinateS1:(GLdouble)_s1
							t1:(GLdouble)_t1
							s2:(GLdouble)_s2
							t2:(GLdouble)_t2
							s3:(GLdouble)_s3
							t3:(GLdouble)_t3
							s4:(GLdouble)_s4
							t4:(GLdouble)_t4;


- (void)draw;
- (void)drawOutline;

- (void)deleteTexture;
- (BOOL)glPredatesGLOnePointOne;

- (NSString *)colorspaceName;
- (void)setColorspaceName:(NSString *)_colorspaceName;

@end
